Bug 1274006 - [RFE] Validation Should Confirm Parameters Used Are Defined
[RFE] Validation Should Confirm Parameters Used Are Defined
Status: ASSIGNED
Product: Red Hat OpenStack
Classification: Red Hat
Component: openstack-tripleo-heat-templates (Show other bugs)
7.0 (Kilo)
Unspecified Unspecified
unspecified Severity low
: Upstream M2
: 15.0 (S)
Assigned To: Florian Fuchs
Arik Chernetsky
NeedsAllocation
: FutureFeature, Triaged
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-10-21 13:31 EDT by Dan Sneddon
Modified: 2018-03-13 11:52 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Dan Sneddon 2015-10-21 13:31:20 EDT
Description of problem:
If the user uses a {get_param: foo} in the nic-configs, but that parameter is not defined in the template, then the nic-config will not be populated properly and deployment will fail.

Version-Release number of selected component (if applicable):
OSP-D 7.1 GA

How reproducible:
100%

Steps to Reproduce:
1. Use a get_param: of a non-defined parameter in the nic-config
2. Deploy
3.

Actual results:
Deployment fails because the parameter is not defined.

Expected results:
We should check for this case before the deployment and issue an error that should be corrected before deployment.

Additional info:
The validation should look at all the values in the get_param: lookups, and verify that the parameter is defined in the parameters: section.
Comment 3 Mike Burns 2016-04-07 16:54:03 EDT
This bug did not make the OSP 8.0 release.  It is being deferred to OSP 10.
Comment 5 Dmitry Tantsur 2017-02-06 10:30:12 EST
Dan, isn't it how THT works in general? I'm pushing it back to THT folks for re-evaluation?

Or should it go to the validations team backlog?
Comment 6 Dan Sneddon 2017-02-06 14:57:25 EST
(In reply to Dmitry Tantsur from comment #5)
> Dan, isn't it how THT works in general? I'm pushing it back to THT folks for
> re-evaluation?
> 
> Or should it go to the validations team backlog?

I think one problem may be that the errors that are thrown by Heat don't make it easy to see what/where the problem is.

This could be addressed by better error reporting, but it is very difficult for end-users to diagnose this failure, as evidenced by the number of customers who have asked for support when they have run into this condition.

In any case, it is always better to fail faster, and I think this would be good for when we integrate validations with the UI. So my vote is to handle this within tripleo-validations.
Comment 7 Emilien Macchi 2017-07-20 13:58:25 EDT
Moving the bug to DFG:UI as it seems to affect TripleO validations - I'm happy to discuss about it, if it's a problem.

Note You need to log in before you can comment on or make changes to this bug.